#include <Octoliner.h>
#include <Arduino.h>
#include <Wire.h>
#include <SoftwareSerial.h>
#include <MeMegaPi.h>
Octoliner octoliner(42);

//Encoder Motor
MeEncoderOnBoard Encoder_1(SLOT1);
MeEncoderOnBoard Encoder_2(SLOT2);
MeEncoderOnBoard Encoder_3(SLOT3);


void isr_process_encoder1(void)
{
      if(digitalRead(Encoder_1.getPortB()) == 0){
            Encoder_1.pulsePosMinus();
      }else{
            Encoder_1.pulsePosPlus();
      }
}

void isr_process_encoder2(void)
{
      if(digitalRead(Encoder_2.getPortB()) == 0){
            Encoder_2.pulsePosMinus();
      }else{
            Encoder_2.pulsePosPlus();
      }
}

void isr_process_encoder3(void)
{
      if(digitalRead(Encoder_3.getPortB()) == 0){
            Encoder_3.pulsePosMinus();
      }else{
            Encoder_3.pulsePosPlus();
      }
}

 

void move(int direction, int speed)
{
      int leftSpeed = 0;
      int rightSpeed = 0;
      if(direction == 1){
            leftSpeed = -speed;
            rightSpeed = speed;
      }else if(direction == 2){
            leftSpeed = speed;
            rightSpeed = -speed;
      }else if(direction == 3){
            leftSpeed = speed;
            rightSpeed = speed;
      }else if(direction == 4){
            leftSpeed = -speed;
            rightSpeed = -speed;
      }
      Encoder_1.setTarPWM(rightSpeed);
      Encoder_2.setTarPWM(leftSpeed);
}
void moveDegrees(int direction,long degrees, int speed_temp)
{
      speed_temp = abs(speed_temp);
      if(direction == 1)
      {
            Encoder_1.move(degrees,(float)speed_temp);
            Encoder_2.move(-degrees,(float)speed_temp);
      }
      else if(direction == 2)
      {
            Encoder_1.move(-degrees,(float)speed_temp);
            Encoder_2.move(degrees,(float)speed_temp);
      }
      else if(direction == 3)
      {
            Encoder_1.move(degrees,(float)speed_temp);
            Encoder_2.move(degrees,(float)speed_temp);
      }
      else if(direction == 4)
      {
            Encoder_1.move(-degrees,(float)speed_temp);
            Encoder_2.move(-degrees,(float)speed_temp);
      }
    
}

double angle_rad = PI/180.0;
double angle_deg = 180.0/PI;
double R;
double R_1;
double R_2;
double L;
double L_1;
double L_2;
double KP;
double KD;
double KD_din;
double Speed;
double ERR;
double ERROLD;
double ES;
double U;

MeMegaPiDCMotor motor_10(10);
MeMegaPiDCMotor motor_9(9);


void setup(){
    //Set Pwm 8KHz
    TCCR1A = _BV(WGM10);
    TCCR1B = _BV(CS11) | _BV(WGM12);
    TCCR2A = _BV(WGM21) | _BV(WGM20);
    TCCR2B = _BV(CS21);


    
    pinMode(A0+6,INPUT); // Левый vex
    pinMode(A0+7,INPUT); // правый vex 
    Serial.begin(115200);

    
    KP=0.001;
    KD=0;
    Speed = 150;

    R =(octoliner.analogRead(7)); //калибровка
    L =(octoliner.analogRead(1)); //калибровка
    ES=R-L;
    Wire.begin();
    octoliner.begin(); 
    octoliner.setSensitivity(210); // выставляем чувствительность фотоприёмников в диапазоне от 0 до 255
    octoliner.setBrightness(255);// выставляем яркость свечения ИК-светодиодов в диапазоне от 0 до 255
    
  
    
}

void loop()
{
     R_1 =(octoliner.analogRead(7)); //левый крайний из 8-модульного
     L_1 =(octoliner.analogRead(1)); //правый крайний из 8-модульного   
     L_2 = analogRead(A0+6);// Левый vex
     R_2 = analogRead(A0+7);// правый vex
     KD_din = KD *(R_2-L_2);
     ERR = (KP*(R_1 - L_1))+(KD_din*(R_1 - L_1-ERROLD));
     U=ERR;  
     motor_10.run((Speed) - (U)); 
     motor_9.run((-(Speed))-(U)); 
     ERROLD = R_1 - L_1;
     
   
    _loop();
}

void _delay(float seconds){
    long endTime = millis() + seconds * 1000;
    while(millis() < endTime)_loop();
}

void _loop(){
     Encoder_1.loop();
    
    Encoder_2.loop();
    
    Encoder_1.loop();
    Encoder_2.loop();
    
    Encoder_3.loop();
}
